-- http://www.iquilezles.org/apps/shadertoy
-- Heart glsl shader preset.
-- by Iñigo Quilez
-- adapted to Love by Ref
local pulse={}

pulse.effect = love.graphics.newPixelEffect[[
	extern number time		= 0.0;
	extern vec2 resolution	= vec2( 800, 800 );
	vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 pixel_coords)
	{
		vec2 p = ( 2.0 * pixel_coords.xy - resolution.xy ) / resolution.y;
		// animate
		float tt	= mod( time, 2.0 )/ 2.0;
		float ss	= pow( tt, 0.2 ) * 0.5 + 0.5;
		ss			-= ss * 0.2 * sin( tt * 6.2831 * 5.0 ) * exp( -tt * 6.0 );
		p			*= vec2( 0.5, 1.5 ) + ss * vec2( 0.5, -0.25 );
		float a		= atan( p.x, p.y ) / 3.141593;
		float r		= length( p );
		// shape
		float h		= abs( a );
		float d		= ( 13.0 * h - 22.0 *h*h + 10.0*h*h*h ) / ( 6.0 - 5.0 * h );
		// color
		float f		= step( r, d ) * pow( 1.0 - r / d, 0.5 );
		float ff		= step( r, d ) * pow( 1.0 - r / d, 0.5 )/(time/2);
		return vec4( f, 0.0, ff, 1.0 );
		}
	]]

return pulse
